﻿Imports Infragistics.Win

Public Class Form1

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles grd.InitializeLayout



        Dim myGroup As UltraWinGrid.UltraGridGroup
        Dim band As UltraWinGrid.UltraGridBand
        Dim col As UltraWinGrid.UltraGridColumn

        band = e.Layout.Bands(0)

        myGroup = band.Groups.Add("Test")
        myGroup.RowLayoutGroupInfo.OriginX = 1
        myGroup.RowLayoutGroupInfo.OriginY = 0
        myGroup.RowLayoutGroupInfo.SpanY = 1
        myGroup.RowLayoutGroupInfo.SpanX = 2
        myGroup.RowLayoutGroupInfo.LabelPosition = UltraWinGrid.LabelPosition.Top
        myGroup.RowLayoutGroupInfo.LabelPosition = UltraWinGrid.LabelPosition.LabelOnly
        myGroup.RowLayoutGroupInfo.LabelSpan = 1
        myGroup.Header.Caption = "Here is a very wide text in the group"

        myGroup.Width = 0

        band.RowLayoutStyle = UltraWinGrid.RowLayoutStyle.GroupLayout
        band.RowLayoutLabelStyle = UltraWinGrid.RowLayoutLabelStyle.Separate

        For Each col In band.Columns
            col.RowLayoutColumnInfo.SpanX = 1
            col.RowLayoutColumnInfo.SpanY = 1
            col.RowLayoutColumnInfo.OriginX = col.Index + 1
            col.RowLayoutColumnInfo.OriginY = 1
            col.RowLayoutColumnInfo.LabelPosition = UltraWinGrid.LabelPosition.Top
            col.Group = myGroup
            myGroup.Width = myGroup.Width + col.Width
        Next

    End Sub

    Private Sub UltraButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UltraButton1.Click
 
        Dim expFile As String = "TestExp.xlsx"
        exp.Export(grd, expFile, Infragistics.Excel.WorkbookFormat.Excel2007)
        Process.Start(expFile)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dt As DataTable = New DataTable()
        dt.Columns.Add("Column 0", GetType(String))
        dt.Columns.Add("Column 1", GetType(String))
        grd.DataSource = dt

    End Sub

    Private Sub exp_HeaderCellExporting(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.ExcelExport.HeaderCellExportingEventArgs) Handles exp.HeaderCellExporting
        ' If (e.HeaderType = UltraWinGrid.ExcelExport.HeaderTypes.GroupHeader) Then
        If (e.GridHeader.Group Is Nothing) Then
            e.CurrentWorksheet.Columns(e.CurrentColumnIndex).Width = e.GridHeader.Column.RowLayoutColumnInfo.ActualCellSize.Width * (256 / grd.Font.Size)
        End If
    End Sub
End Class
